diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
index cd1757f62..243c3c75d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
@@ -87,28 +87,28 @@ public class BlockLogicPistonHead extends BlockLogic
         switch(getDirectionFromMeta(world.getBlockMetadata(x, y, z)))
         {
             case DOWN:
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F).move(x, y, z), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5 - this.shaftThickness/2, this.headThickness, 0.5 - this.shaftThickness/2, 0.5 + this.shaftThickness/2, 1 + this.headThickness, 0.5 + this.shaftThickness/2).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - this.shaftThickness/2, this.headThickness, 0.5 - this.shaftThickness/2, 0.5 + this.shaftThickness/2, 1 + this.headThickness, 0.5 + this.shaftThickness/2).move(x, y, z), aabbList);
                 break;
             case UP:
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5 - this.shaftThickness/2, -this.headThickness, 0.5 - this.shaftThickness/2, 0.5 + this.shaftThickness/2, 1 - this.headThickness, 0.5 + this.shaftThickness/2).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - this.shaftThickness/2, -this.headThickness, 0.5 - this.shaftThickness/2, 0.5 + this.shaftThickness/2, 1 - this.headThickness, 0.5 + this.shaftThickness/2).move(x, y, z), aabbList);
                 break;
             case NORTH:
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness).move(x, y, z), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5 - this.shaftThickness/2, 0.5 - this.shaftThickness/2, this.headThickness, 0.5 + this.shaftThickness/2, 0.5 + this.shaftThickness/2, 1 + this.headThickness).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - this.shaftThickness/2, 0.5 - this.shaftThickness/2, this.headThickness, 0.5 + this.shaftThickness/2, 0.5 + this.shaftThickness/2, 1 + this.headThickness).move(x, y, z), aabbList);
                 break;
             case SOUTH:
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.5 - this.shaftThickness/2, 0.5 - this.shaftThickness/2, -this.headThickness, 0.5 + this.shaftThickness/2, 0.5 + this.shaftThickness/2, 1 - this.headThickness).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.5 - this.shaftThickness/2, 0.5 - this.shaftThickness/2, -this.headThickness, 0.5 + this.shaftThickness/2, 0.5 + this.shaftThickness/2, 1 - this.headThickness).move(x, y, z), aabbList);
                 break;
             case WEST:
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F).move(x, y, z), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(this.headThickness, 0.5 - this.shaftThickness/2, 0.5 - this.shaftThickness/2, 1 + this.headThickness, 0.5 + this.shaftThickness/2, 0.5 + this.shaftThickness/2).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(this.headThickness, 0.5 - this.shaftThickness/2, 0.5 - this.shaftThickness/2, 1 + this.headThickness, 0.5 + this.shaftThickness/2, 0.5 + this.shaftThickness/2).move(x, y, z), aabbList);
                 break;
             case EAST:
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
-                addIntersectingBoundingBox(aabb, AABB.getTemporaryBB(-this.headThickness, 0.5 - this.shaftThickness/2, 0.5 - this.shaftThickness/2, 1 - this.headThickness, 0.5 + this.shaftThickness/2, 0.5 + this.shaftThickness/2).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F).move(x, y, z), aabbList);
+                addIntersectingBoundingBox(aabb, AABB.fromPool(-this.headThickness, 0.5 - this.shaftThickness/2, 0.5 - this.shaftThickness/2, 1 - this.headThickness, 0.5 + this.shaftThickness/2, 0.5 + this.shaftThickness/2).move(x, y, z), aabbList);
                 break;
         }
     }
@@ -120,17 +120,17 @@ public class BlockLogicPistonHead extends BlockLogic
         switch(getDirectionFromMeta(l))
         {
             case DOWN:
-                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F);
+                return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F);
             case UP:
-                return AABB.getTemporaryBB(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
+                return AABB.fromPool(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
             case NORTH:
-                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness);
+                return AABB.fromPool(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness);
             case SOUTH:
-                return AABB.getTemporaryBB(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F);
+                return AABB.fromPool(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F);
             case WEST:
-                return AABB.getTemporaryBB(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F);
+                return AABB.fromPool(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F);
             case EAST:
-                return AABB.getTemporaryBB(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                return AABB.fromPool(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
         }
         return super.getBlockBoundsFromState(world, x, y, z);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
index 0ecafdb2f..32b9cfe97 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
@@ -151,7 +151,7 @@ public class BlockLogicPistonMoving extends BlockLogic
             }
             Direction direction = pistonTileEntity.getDirection();
             AABB otherBounds = block.getBlockBoundsFromState(world, x, y, z);
-            return AABB.getTemporaryBB(
+            return AABB.fromPool(
             otherBounds.minX - direction.getOffsetX() * f,
             otherBounds.maxX - direction.getOffsetX() * f,
             otherBounds.minY - direction.getOffsetY() * f,
diff --git a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
index 9ce38edc6..c63f89a1c 100644
--- a/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
+++ b/game/core/src/main/java/net/minecraft/core/data/registry/recipe/adapter/ItemStackJsonAdapter.java
@@ -52,7 +52,7 @@ public class ItemStackJsonAdapter implements JsonDeserializer<ItemStack>, JsonSe
                 item = Item.itemsList[e.getAsInt()];
             } catch (NumberFormatException ignored) { // NumberFormatException thrown if element is not actually convertible to a number
                 try {
-                    item = Item.itemsMap.get(NamespaceID.getTemp(e.getAsString()));
+                    item = Item.itemsMap.get(NamespaceID.fromPool(e.getAsString()));
                 } catch (HardIllegalArgumentException ex) {
                     throw new JsonParseException(ex);
                 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index 53b096042..20089d7d6 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -39,6 +39,8 @@ import net.minecraft.core.world.data.SynchedEntityData;
 public abstract class Entity
     implements IVehicle
 {
+    private static @NotNull AABB DEFAULT_AABB = AABB.fromPool(0.0, 0.0, 0.0, 0.0, 0.0, 0.0);
+
     public static final int DATA_SHARED_FLAGS_ID = 0;
     public static final int FLAG_ONFIRE = 0;
     public static final int FLAG_SNEAKING = 1;
@@ -66,7 +68,7 @@ public abstract class Entity
     public float xRotO;
     public float pushTime;
     public int pushesThisTick;
-    public final @NotNull AABB bb = AABB.getPermanentBB(0.0D, 0.0D, 0.0D, 0.0D, 0.0D, 0.0D);
+    public final @NotNull AABB bb = Entity.DEFAULT_AABB.copyUnpooled();
     public boolean onGround = false;
     public boolean horizontalCollision;
     public boolean verticalCollision;
@@ -467,7 +469,7 @@ public abstract class Entity
         double bbWidth = bb.maxX - bb.minX - 0.05;
         if(isSneaking()) { // Edge safety behavior
 			if(xd != 0.0) {
-				AABB floor = AABB.getTemporaryBB(bb.minX, bb.minY - 1.0, bb.minZ, bb.maxX, bb.minY, bb.maxZ).expand(xd, 0.0, 0.0);
+				AABB floor = AABB.fromPool(bb.minX, bb.minY - 1.0, bb.minZ, bb.maxX, bb.minY, bb.maxZ).expand(xd, 0.0, 0.0);
 				List<AABB> collidingBoxes = world.getCubes(this, floor);
 				if(!collidingBoxes.isEmpty()) {
 					double limitX = 0.0;
@@ -487,7 +489,7 @@ public abstract class Entity
 				}
 			}
 			if(zd != 0.0) {
-				AABB floor = AABB.getTemporaryBB(bb.minX, bb.minY - 1.0, bb.minZ, bb.maxX, bb.minY, bb.maxZ).expand(0.0, 0.0, zd);
+				AABB floor = AABB.fromPool(bb.minX, bb.minY - 1.0, bb.minZ, bb.maxX, bb.minY, bb.maxZ).expand(0.0, 0.0, zd);
 				List<AABB> collidingBoxes = world.getCubes(this, floor);
 				if(!collidingBoxes.isEmpty()) {
 					double limitZ = 0.0;
@@ -625,7 +627,7 @@ public abstract class Entity
             walkDist += (double) MathHelper.sqrt(d10 * d10 + d12 * d12) * 0.6;
             
             // Tiny bounding box
-            AABB boundingBox = AABB.getPermanentBB(this.x - 0.01, this.bb.minY - 0.01, this.z - 0.01, this.x + 0.01, this.bb.minY + 0.01, this.z + 0.01);
+            AABB boundingBox = AABB.fromPool(this.x - 0.01, this.bb.minY - 0.01, this.z - 0.01, this.x + 0.01, this.bb.minY + 0.01, this.z + 0.01);
 
             int blockX = MathHelper.floor(this.x);
             int blockY = MathHelper.floor(boundingBox.minY);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
index 714838cdc..a6ae82946 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
@@ -50,14 +50,15 @@ public final class EntityDispatcher
         if (classToIdMap.containsKey(entityClass)) {
             throw new IllegalArgumentException("EntityDispatcher already contains an assignment for class " + entityClass.getSimpleName() + " with namespace " + classToIdMap.get(entityClass) + "!");
         }
-        namespaceID.makePermanent();
-        classToIdMap.put(entityClass, namespaceID);
-        idToClassMap.put(namespaceID, entityClass);
-        stringIdToClassMap.put(namespaceID.toString(), entityClass);
+        final @NotNull NamespaceID unpooledNamespaceID = namespaceID.copyUnpooled();
+
+        classToIdMap.put(entityClass, unpooledNamespaceID);
+        idToClassMap.put(unpooledNamespaceID, entityClass);
+        stringIdToClassMap.put(unpooledNamespaceID.toString(), entityClass);
 
         int numericId = mappingCount++;
         numericIdToClassMap.put(numericId, entityClass);
-        numericIdToStringIdMap.put(numericId, namespaceID.toString());
+        numericIdToStringIdMap.put(numericId, unpooledNamespaceID.toString());
         classToNumericIdMap.put(entityClass, numericId);
 
         if (nameKey != null) {
@@ -186,51 +187,51 @@ public final class EntityDispatcher
         hasInit = true;
 
         // Misc
-        addMapping(EntityItem.class, NamespaceID.getPermanent("minecraft", "item"));
-        addMapping(EntityPainting.class, NamespaceID.getPermanent("minecraft", "painting"));
-        addMapping(EntityLightning.class, NamespaceID.getPermanent("minecraft", "lightning"));
-        addMapping(EntityFallingBlock.class, NamespaceID.getPermanent("minecraft", "falling_block"));
-        addMapping(EntityMinecart.class, NamespaceID.getPermanent("minecraft", "minecart"));
-        addMapping(EntityBoat.class, NamespaceID.getPermanent("minecraft", "boat"));
-        addMapping(EntityPrimedTNT.class, NamespaceID.getPermanent("minecraft", "primed_tnt"));
+        addMapping(EntityItem.class, NamespaceID.fromPool("minecraft", "item"));
+        addMapping(EntityPainting.class, NamespaceID.fromPool("minecraft", "painting"));
+        addMapping(EntityLightning.class, NamespaceID.fromPool("minecraft", "lightning"));
+        addMapping(EntityFallingBlock.class, NamespaceID.fromPool("minecraft", "falling_block"));
+        addMapping(EntityMinecart.class, NamespaceID.fromPool("minecraft", "minecart"));
+        addMapping(EntityBoat.class, NamespaceID.fromPool("minecraft", "boat"));
+        addMapping(EntityPrimedTNT.class, NamespaceID.fromPool("minecraft", "primed_tnt"));
 
         // Projectiles
-        addMapping(ProjectilePebble.class, NamespaceID.getPermanent("minecraft", "pebble"));
-        addMapping(ProjectileEgg.class, NamespaceID.getPermanent("minecraft", "egg"));
-        addMapping(ProjectileArrow.class, NamespaceID.getPermanent("minecraft", "arrow"));
-        addMapping(ProjectileArrowGolden.class, NamespaceID.getPermanent("minecraft", "arrow_golden"));
-        addMapping(ProjectileArrowPurple.class, NamespaceID.getPermanent("minecraft", "arrow_purple"));
-        addMapping(ProjectileSnowball.class, NamespaceID.getPermanent("minecraft", "snowball"));
-        addMapping(ProjectileFireball.class, NamespaceID.getPermanent("minecraft", "fireball"));
-        addMapping(ProjectileCannonball.class, NamespaceID.getPermanent("minecraft", "cannonball"));
-
-        addMapping(Mob.class, NamespaceID.getPermanent("minecraft", "mob")); // Abstract class, shouldn't ever be instantiated
-        addMapping(MobHuman.class, NamespaceID.getPermanent("minecraft", "human"));
-        addMapping(Player.class, NamespaceID.getPermanent("minecraft", "player"));
+        addMapping(ProjectilePebble.class, NamespaceID.fromPool("minecraft", "pebble"));
+        addMapping(ProjectileEgg.class, NamespaceID.fromPool("minecraft", "egg"));
+        addMapping(ProjectileArrow.class, NamespaceID.fromPool("minecraft", "arrow"));
+        addMapping(ProjectileArrowGolden.class, NamespaceID.fromPool("minecraft", "arrow_golden"));
+        addMapping(ProjectileArrowPurple.class, NamespaceID.fromPool("minecraft", "arrow_purple"));
+        addMapping(ProjectileSnowball.class, NamespaceID.fromPool("minecraft", "snowball"));
+        addMapping(ProjectileFireball.class, NamespaceID.fromPool("minecraft", "fireball"));
+        addMapping(ProjectileCannonball.class, NamespaceID.fromPool("minecraft", "cannonball"));
+
+        addMapping(Mob.class, NamespaceID.fromPool("minecraft", "mob")); // Abstract class, shouldn't ever be instantiated
+        addMapping(MobHuman.class, NamespaceID.fromPool("minecraft", "human"));
+        addMapping(Player.class, NamespaceID.fromPool("minecraft", "player"));
 
         // Hostile
-        addMapping(MobZombie.class, NamespaceID.getPermanent("minecraft", "zombie"), "guidebook.section.mob.zombie.name");
-        addMapping(MobZombieArmored.class, NamespaceID.getPermanent("minecraft", "zombie_armored"), "guidebook.section.mob.armored_zombie.name");
-        addMapping(MobZombiePig.class, NamespaceID.getPermanent("minecraft", "zombie_pigman"), "guidebook.section.mob.zombie_pigman.name");
-        addMapping(MobCreeper.class, NamespaceID.getPermanent("minecraft", "creeper"), "guidebook.section.mob.creeper.name");
-        addMapping(MobSkeleton.class, NamespaceID.getPermanent("minecraft", "skeleton"), "guidebook.section.mob.skeleton.name");
-        addMapping(MobSpider.class, NamespaceID.getPermanent("minecraft", "spider"), "guidebook.section.mob.spider.name");
-        addMapping(MobGiant.class, NamespaceID.getPermanent("minecraft", "giant"));
-        addMapping(MobSlime.class, NamespaceID.getPermanent("minecraft", "slime"), "guidebook.section.mob.slime.name");
-        addMapping(MobGhast.class, NamespaceID.getPermanent("minecraft", "ghast"), "guidebook.section.mob.ghast.name");
-        addMapping(MobSnowman.class, NamespaceID.getPermanent("minecraft", "snowman"), "guidebook.section.mob.snowman.name");
+        addMapping(MobZombie.class, NamespaceID.fromPool("minecraft", "zombie"), "guidebook.section.mob.zombie.name");
+        addMapping(MobZombieArmored.class, NamespaceID.fromPool("minecraft", "zombie_armored"), "guidebook.section.mob.armored_zombie.name");
+        addMapping(MobZombiePig.class, NamespaceID.fromPool("minecraft", "zombie_pigman"), "guidebook.section.mob.zombie_pigman.name");
+        addMapping(MobCreeper.class, NamespaceID.fromPool("minecraft", "creeper"), "guidebook.section.mob.creeper.name");
+        addMapping(MobSkeleton.class, NamespaceID.fromPool("minecraft", "skeleton"), "guidebook.section.mob.skeleton.name");
+        addMapping(MobSpider.class, NamespaceID.fromPool("minecraft", "spider"), "guidebook.section.mob.spider.name");
+        addMapping(MobGiant.class, NamespaceID.fromPool("minecraft", "giant"));
+        addMapping(MobSlime.class, NamespaceID.fromPool("minecraft", "slime"), "guidebook.section.mob.slime.name");
+        addMapping(MobGhast.class, NamespaceID.fromPool("minecraft", "ghast"), "guidebook.section.mob.ghast.name");
+        addMapping(MobSnowman.class, NamespaceID.fromPool("minecraft", "snowman"), "guidebook.section.mob.snowman.name");
 
         // Passive
-        addMapping(MobScorpion.class, NamespaceID.getPermanent("minecraft", "scorpion"));
-        addMapping(MobPig.class, NamespaceID.getPermanent("minecraft", "pig"), "guidebook.section.mob.pig.name");
-        addMapping(MobSheep.class, NamespaceID.getPermanent("minecraft", "sheep"), "guidebook.section.mob.sheep.name");
-        addMapping(MobCow.class, NamespaceID.getPermanent("minecraft", "cow"), "guidebook.section.mob.cow.name");
-        addMapping(MobChicken.class, NamespaceID.getPermanent("minecraft", "chicken"), "guidebook.section.mob.chicken.name");
-        addMapping(MobSquid.class, NamespaceID.getPermanent("minecraft", "squid"), "guidebook.section.mob.squid.name");
-        addMapping(MobWolf.class, NamespaceID.getPermanent("minecraft", "wolf"), "guidebook.section.mob.wolf.name");
-        addMapping(MobFireflyCluster.class, NamespaceID.getPermanent("minecraft", "firefly_cluster"), "guidebook.section.mob.firefly_cluster.name");
-        addMapping(MobButterfly.class, NamespaceID.getPermanent("minecraft", "butterfly"), "guidebook.section.mob.butterfly.name");
-        addMapping(MobDeer.class, NamespaceID.getPermanent("minecraft", "deer"), "guidebook.section.mob.deer.name");
+        addMapping(MobScorpion.class, NamespaceID.fromPool("minecraft", "scorpion"));
+        addMapping(MobPig.class, NamespaceID.fromPool("minecraft", "pig"), "guidebook.section.mob.pig.name");
+        addMapping(MobSheep.class, NamespaceID.fromPool("minecraft", "sheep"), "guidebook.section.mob.sheep.name");
+        addMapping(MobCow.class, NamespaceID.fromPool("minecraft", "cow"), "guidebook.section.mob.cow.name");
+        addMapping(MobChicken.class, NamespaceID.fromPool("minecraft", "chicken"), "guidebook.section.mob.chicken.name");
+        addMapping(MobSquid.class, NamespaceID.fromPool("minecraft", "squid"), "guidebook.section.mob.squid.name");
+        addMapping(MobWolf.class, NamespaceID.fromPool("minecraft", "wolf"), "guidebook.section.mob.wolf.name");
+        addMapping(MobFireflyCluster.class, NamespaceID.fromPool("minecraft", "firefly_cluster"), "guidebook.section.mob.firefly_cluster.name");
+        addMapping(MobButterfly.class, NamespaceID.fromPool("minecraft", "butterfly"), "guidebook.section.mob.butterfly.name");
+        addMapping(MobDeer.class, NamespaceID.fromPool("minecraft", "deer"), "guidebook.section.mob.deer.name");
     }
 
     @Deprecated
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java b/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
index 5e37c36ed..186d33348 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
@@ -212,14 +212,14 @@ public class EntityFishingBobber extends Entity
             }
         }
         ticksInAir++;
-        Vec3 currentPos = Vec3.getTempVec3(x, y, z);
-        Vec3 nextPos = Vec3.getTempVec3(x + xd, y + yd, z + zd);
+        Vec3 currentPos = Vec3.fromPool(x, y, z);
+        Vec3 nextPos = Vec3.fromPool(x + xd, y + yd, z + zd);
         HitResult clip = world.checkBlockCollisionBetweenPoints(currentPos, nextPos);
-        currentPos = Vec3.getTempVec3(x, y, z);
-        nextPos = Vec3.getTempVec3(x + xd, y + yd, z + zd);
+        currentPos = Vec3.fromPool(x, y, z);
+        nextPos = Vec3.fromPool(x + xd, y + yd, z + zd);
         if(clip != null)
         {
-            nextPos = Vec3.getTempVec3(clip.location.x, clip.location.y, clip.location.z);
+            nextPos = Vec3.fromPool(clip.location.x, clip.location.y, clip.location.z);
             if (clip.hitType == HitResult.HitType.TILE && world.getBlockId(clip.x, clip.y, clip.z) == Blocks.ROPE.id()) {
                 setInGround(true);
                 xTile = clip.x;
@@ -283,7 +283,7 @@ public class EntityFishingBobber extends Entity
         {
             double d8 = ((bb.minY + ((bb.maxY - bb.minY) * (double)(l)) / (double)k) - 0.125D) + 0.125D;
             double d9 = ((bb.minY + ((bb.maxY - bb.minY) * (double)(l + 1)) / (double)k) - 0.125D) + 0.125D;
-            AABB axisalignedbb1 = AABB.getTemporaryBB(bb.minX, d8, bb.minZ, bb.maxX, d9, bb.maxZ);
+            AABB axisalignedbb1 = AABB.fromPool(bb.minX, d8, bb.minZ, bb.maxX, d9, bb.maxZ);
 
             if(world.isAABBInMaterial(axisalignedbb1, Material.water))
             {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java b/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
index b08216347..b6235fd3e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
@@ -67,7 +67,7 @@ public class EntityLightning extends Entity
         if(life >= 0)
         {
             double radius = 3D;
-            List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, AABB.getTemporaryBB(x - radius, y - radius, z - radius, x + radius, y + 6D + radius, z + radius));
+            List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, AABB.fromPool(x - radius, y - radius, z - radius, x + radius, y + 6D + radius, z + radius));
             for (Entity entity : list)
             {
                 entity.thunderHit(this);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java b/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
index f10457f4a..821ffff80 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityPainting.java
@@ -376,20 +376,20 @@ public class EntityPainting extends Entity
         }
     }
     private static final HashMap<String, String> borderMaterialMap = new HashMap<>();
-    public static void addBorder(ItemStack stack, NamespaceID imagePath){
+    public static void addBorder(ItemStack stack, NamespaceID imagePath) {
         borderMaterialMap.put(stack.itemID + "|" + stack.getMetadata(), String.format("/assets/%s/textures/art/borders/%s.png", imagePath.namespace(), imagePath.value()));
     }
     public static String getBorder(ItemStack stack){
         return borderMaterialMap.get(stack.itemID + "|" + stack.getMetadata());
     }
     static {
-        addBorder(Items.INGOT_IRON.getDefaultStack(), NamespaceID.getPermanent("minecraft", "border_iron"));
-        addBorder(Items.INGOT_GOLD.getDefaultStack(), NamespaceID.getPermanent("minecraft", "border_gold"));
-        addBorder(Items.INGOT_STEEL.getDefaultStack(), NamespaceID.getPermanent("minecraft", "border_steel"));
-        addBorder(new ItemStack(Items.DYE, 1, 4), NamespaceID.getPermanent("minecraft", "border_lapis"));
-        addBorder(Items.DIAMOND.getDefaultStack(), NamespaceID.getPermanent("minecraft", "border_diamond"));
-        addBorder(Items.DUST_REDSTONE.getDefaultStack(), NamespaceID.getPermanent("minecraft", "border_redstone"));
-        addBorder(Items.OLIVINE.getDefaultStack(), NamespaceID.getPermanent("minecraft", "border_olivine"));
-        addBorder(Items.QUARTZ.getDefaultStack(), NamespaceID.getPermanent("minecraft", "border_quartz"));
+        addBorder(Items.INGOT_IRON.getDefaultStack(), NamespaceID.fromPool("minecraft", "border_iron"));
+        addBorder(Items.INGOT_GOLD.getDefaultStack(), NamespaceID.fromPool("minecraft", "border_gold"));
+        addBorder(Items.INGOT_STEEL.getDefaultStack(), NamespaceID.fromPool("minecraft", "border_steel"));
+        addBorder(new ItemStack(Items.DYE, 1, 4), NamespaceID.fromPool("minecraft", "border_lapis"));
+        addBorder(Items.DIAMOND.getDefaultStack(), NamespaceID.fromPool("minecraft", "border_diamond"));
+        addBorder(Items.DUST_REDSTONE.getDefaultStack(), NamespaceID.fromPool("minecraft", "border_redstone"));
+        addBorder(Items.OLIVINE.getDefaultStack(), NamespaceID.fromPool("minecraft", "border_olivine"));
+        addBorder(Items.QUARTZ.getDefaultStack(), NamespaceID.fromPool("minecraft", "border_quartz"));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index 7f7b511b8..2d5bf8b3e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -101,7 +101,7 @@ public abstract class Mob extends Entity
     protected @NotNull String basePath = "/assets/minecraft/textures/entity/char/";
     protected @NotNull String defaultTexture = "/assets/minecraft/textures/entity/char/0.png";
     protected @NotNull String variantJsonPath = "/assets/minecraft/textures/entity/char/variant.json";
-    protected @NotNull NamespaceID textureIdentifier = NamespaceID.getPermanent("minecraft", "char");
+    protected @NotNull NamespaceID textureIdentifier = NamespaceID.fromPool("minecraft", "char").copyUnpooled();
 
     public boolean isSkating = false;
 
@@ -168,7 +168,7 @@ public abstract class Mob extends Entity
 
     public boolean canEntityBeSeen(Entity entity)
     {
-        return world.checkBlockCollisionBetweenPoints(Vec3.getTempVec3(x, y + (double) getHeadHeight(), z), Vec3.getTempVec3(entity.x, entity.y + (double)entity.getHeadHeight(), entity.z)) == null;
+        return world.checkBlockCollisionBetweenPoints(Vec3.fromPool(x, y + (double) getHeadHeight(), z), Vec3.fromPool(entity.x, entity.y + (double)entity.getHeadHeight(), entity.z)) == null;
     }
 
     @Override
@@ -1225,13 +1225,13 @@ public abstract class Mob extends Entity
     {
         if(partialTick == 1.0F)
         {
-            return Vec3.getTempVec3(x, y + (headOffset ? getHeadHeight() : 0), z);
+            return Vec3.fromPool(x, y + (headOffset ? getHeadHeight() : 0), z);
         } else
         {
             double x = MathHelper.lerp(xo, this.x, partialTick);
             double y = MathHelper.lerp(yo, this.y, partialTick);
             double z = MathHelper.lerp(zo, this.z, partialTick);
-            return Vec3.getTempVec3(x, y + (headOffset ? getHeadHeight() : 0), z);
+            return Vec3.fromPool(x, y + (headOffset ? getHeadHeight() : 0), z);
         }
     }
 
@@ -1244,7 +1244,7 @@ public abstract class Mob extends Entity
             float x = MathHelper.sin(-yRot * (MathHelper.PI / 180f) - MathHelper.PI);
             float xzLen = -MathHelper.cos(-xRot * (MathHelper.PI / 180f));
             float y = MathHelper.sin(-xRot * (MathHelper.PI / 180f));
-            return Vec3.getTempVec3(x * xzLen, y, z * xzLen);
+            return Vec3.fromPool(x * xzLen, y, z * xzLen);
         }
         else
         {
@@ -1254,12 +1254,12 @@ public abstract class Mob extends Entity
             float x = MathHelper.sin(-yaw * (MathHelper.PI / 180f) - MathHelper.PI);
             float y = MathHelper.sin(-pitch * (MathHelper.PI / 180f));
             float z = MathHelper.cos(-yaw * (MathHelper.PI / 180f) - MathHelper.PI);
-            return Vec3.getTempVec3(x * xzLen, y, z * xzLen);
+            return Vec3.fromPool(x * xzLen, y, z * xzLen);
         }
     }
 
 
-    public HitResult rayTrace(double distance, float partialTick, boolean collideWithFluids, boolean ignoreNonColliderBlocks, boolean useSelectorBoxes)
+    public @Nullable HitResult rayTrace(double distance, float partialTick, boolean collideWithFluids, boolean ignoreNonColliderBlocks, boolean useSelectorBoxes)
     {
         Vec3 head = getPosition(partialTick, true);
         Vec3 viewDirection = getViewVector(partialTick);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java b/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java
index 4418c052c..bb75ed9c4 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java
@@ -145,7 +145,7 @@ public abstract class MobPathfinder extends Mob
     }
 
     protected @Nullable Entity getClosestFireflyToEntity (int x, int y, int z, float radius){
-        List<MobFireflyCluster> nearbyFireflies = world.getEntitiesWithinAABB(MobFireflyCluster.class, AABB.getTemporaryBB(this.x, this.y, this.z, this.x + 1.0D, this.y + 1.0D, this.z + 1.0D).grow(radius, 4D, radius));
+        List<MobFireflyCluster> nearbyFireflies = world.getEntitiesWithinAABB(MobFireflyCluster.class, AABB.fromPool(this.x, this.y, this.z, this.x + 1.0D, this.y + 1.0D, this.z + 1.0D).grow(radius, 4D, radius));
 
         double closestDistance = -1D;
         MobFireflyCluster cluster = null;
